Package: EDIRquery
Title: Query the EDIR Database For Specific Gene
Version: 1.12.0
Authors@R: 
    person("Laura D.T.", "Vo Ngoc", , "doan.vongoc@vub.be", 
            role = c("aut", "cre"), comment = c(ORCID = "0000-0002-1597-900X"))
Description: EDIRquery provides a tool to search for genes of interest within the Exome Database of Interspersed Repeats (EDIR). A gene name is a required input, and users can additionally specify repeat sequence lengths, minimum and maximum distance between sequences, and whether to allow a 1-bp mismatch. Outputs include a summary of results by repeat length, as well as a dataframe of query results. Example data provided includes a subset of the data for the gene GAA (ENSG00000171298). To query the full database requires providing a path to the downloaded database files as a parameter.
License: GPL-3
Encoding: UTF-8
biocViews: Genetics, SequenceMatching
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.3
Depends: R (>= 4.2.0)
Imports: tibble (>= 3.1.6), tictoc (>= 1.0.1), utils (>= 4.1.3), stats
        (>= 4.1.3), readr (>= 2.1.2), InteractionSet (>= 1.22.0),
        GenomicRanges (>= 1.46.1)
Suggests: knitr, rmarkdown, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/EDIRquery
git_branch: RELEASE_3_23
git_last_commit: f93b460
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:53:58 UTC; biocbuild
Author: Laura D.T. Vo Ngoc [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1597-900X>)
Maintainer: Laura D.T. Vo Ngoc <doan.vongoc@vub.be>

# EDIRquery
---
## Introduction 

Intragenic exonic deletions are known to contribute to genetic diseases and are 
often flanked by regions of homology. The Exome Database of Interspersed Repeats
(EDIR) was developed to provide an overview of the positions of repetitive 
structures within the human genome composed of interspersed repeats encompassing
a coding sequence. 

The package `EDIRquery` provides user-friendly tools to query
this database for genes of interest.


&nbsp;
### Dataset

EDIR provides a dataset of pairwise repeat structures in which both sequences are located within a maximum of 1000 bp from each other, differ by at most a 1-bp mismatch, and and fulfill one of the following selection criteria:

-   \>= 1 repeat located in an exon
-   Both repeats situated in different introns flanking one or more exons

Example data provided includes a subset of the data for the gene GAA 
(ENSG00000171298) on chromosome 17. 

To query the full the database, download the files at the link below, and provide 
the data directory to `gene_lookup()` in the `path` parameter.

&nbsp;
### Usage
#### Installation
To install this package, enter the following in R:

```{r, eval=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("EDIRquery")
```

Then load the package:


```{r}
library("EDIRquery")
```

&nbsp;

EDIR can easily be queried using the `gene_lookup` function, using the gene name
and additional parameters:

| Argument | Description                                                                                                                                       | Default |
|----------------|---------------------------------------------|-----------|
| gene     | **required:** The gene name (ENSEMBLE ID or HGNC symbol)                                                                                          | \-      |
| length   | Repeat sequence length, must be between 7 and 20. If NA, results will include all available lengths in dataset for queried gene  | NA      |
| mindist  | Minimum spacer distance (bp) between repeats        | 0       |
| maxdist  | Maximum spacer distance (bp) between repeats                                                                                                      | 1000    |
| summary  | Logical value indicating whether to store summary                                                                                               | FALSE   |
| mismatch | Logical value indicating whether to allow 1 mismatch in sequence                                                                                  | TRUE    |
| path     | String containing path to directory holding downloaded dataset files. If not provided (`path = NA`), example subset of data will be used | NA      |

A summary of the input printed to console, including the gene name, gene length 
(bp), Ensembl transcript ID, queried distance between repeats (default: 0-1000 
bp), and an overview of total results for the given repeat length. Console 
outputs include runtime.

&nbsp;
### Examples

Example querying the gene "GAA" with repeats of length 7, and allowing for 
1 mismatch:

```{r}
# Summary of results (printed to console)
gene_lookup("GAA", length = 7, mismatch = TRUE)
```

If no `length` is provided, a summary of all available repeat length results will
be printed:

```{r}
# Summary of results (printed to console)
gene_lookup("GAA", mismatch = TRUE)
```

Storing the output in a variable allows viewing of the individual results in the 
output dataframe:

```{r}
# Database output of query
results <- gene_lookup("GAA", length = 7, mismatch = TRUE)
head(results)
```
---
## Links
- Full dataset download: 
  - https://osf.io/m3gvx/
  - [Direct download](http://193.70.34.71/EDIR.tar.gz)

---
## Contact
Laura DT Vo Ngoc: doan.vongoc@vub.be

#' Look Up a Gene in EDIR Dataset
#'
#' This function searches for a specified gene in the EDIR dataset. A gene name
#' is a required parameter.
#'
#' Summary of results printed to console includes gene name, gene length (bp),
#' Ensembl transcript ID, queried distance between repeats (default: 0-1000 bp),
#' and an overview of total results for the given repeat length. Console outputs
#' include runtime.
#'
#' @param gene The gene name (ENSEMBL ID or HGNC symbol)
#' @param length Repeat sequence length, must be between 7 and 20. Defaults to
#' NA. If NA, results will include all available lengths in dataset for queried
#' gene.
#' @param mindist Minimum spacer distance between repeats. Defaults to 0.
#' @param maxdist Maximum spacer distance between repeats. Defaults to 1000.
#' @param format Output table format. One of 'data.frame', 'GInteractions'.
#' Defaults to 'data.frame'.
#' @param summary Logical value indicating whether to store summary. Defaults
#' to FALSE.
#' @return A data.frame of the results from the EDIR database. If
#' `summary = TRUE`, returns a tibble containing the summary
#' (`$summary`), and query results (`$results`).
#' @param mismatch Logical value indicating whether to allow 1 mismatch in
#' sequences. Defaults to TRUE.
#' @param path String containing path to directory holding downloaded dataset
#' files. Defaults to NA. If not provided (`path` = NA),
#' `gene_lookup()` will use subset of data provided as example.
#' @examples
#' ## With given repeat length,
#' gene_lookup("GAA", length = 7, mindist = 10, maxdist = 1000,
#'             mismatch = TRUE)
#'
#' ## Without specified repeat length
#' gene_lookup("GAA", mindist = 0, maxdist = 1000, mismatch = TRUE)
#'
#' ## To access query results, store in variable
#' output <- gene_lookup("GAA", length = 7, mindist = 10, maxdist = 1000,
#'                         mismatch = FALSE)
#' head(output)
#'
#' ## With summary = TRUE
#' output <- gene_lookup("GAA", length = 10, mindist = 10, maxdist = 1000,
#'                         summary = TRUE,
#'                         mismatch = TRUE)
#' output$summary
#' head(output$results)
#' @export gene_lookup
#'
#' @import utils
#' @import GenomicRanges
#' @importFrom InteractionSet GInteractions
#' @importFrom readr read_delim_chunked DataFrameCallback cols col_double col_character
#' @importFrom stats setNames
#' @importFrom tictoc tic toc
#' @importFrom tibble lst
#'


gene_lookup <- function(gene,
                        length = NA,
                        mindist = 0,
                        maxdist = 1000,
                        format = 'data.frame',
                        summary = FALSE,
                        mismatch = TRUE,
                        path = NA) {
    #Initialize: uppercase gene ID, get chromosome number
    gene <- toupper(gene)

    # USER INPUT CHECK
    # Gene ID incorrect, or not Ensembl ID/HGNC symbol
    if (is.na(any(gene_chr == gene)) || !any(gene_chr == gene)) {
        stop("Incorrect gene ID: use ENSEMBL ID or HGNC symbol")
    }

    # Minimum distance >= maximun distance
    if (mindist >= maxdist) {
        stop("mindist must be less than maxdist")
    }

    # Format must be either 'data.frame' or 'GInteractions'
    if (!(format %in% c('data.frame','GInteractions'))) {
        stop("Format must be one of 'data.frame' or 'GInteractions'")
    }

    tic("Runtime")


    # Initialize filter and coltypes for readr
    gen_filter <- function(gene) {
        function(x, pos) {
            # subset(x, hgnc_symbol %in% gene | ensembl_gene_id %in% gene)
            subset(x, hgnc_symbol %in% gene |
                        ensembl_gene_id %in% gene)
        }
    }
    col_types <- cols(
        chromosome = col_double(),
        repeat_length = col_double(),
        repeat_seq = col_character(),
        start = col_double(),
        end = col_double(),
        repeat_seq2 = col_character(),
        start2 = col_double(),
        end2 = col_double(),
        distance = col_double(),
        ensembl_gene_id = col_character(),
        hgnc_symbol = col_character(),
        gene_range = col_character(),
        ensembl_transcript_id = col_character(),
        transcript_range = col_character(),
        intron_exon = col_character(),
        intron_exon2 = col_character(),
        feature = col_character(),
        mismatch = col_double()
    )

    # Get chromosome number
    chromosome <-
        gene_chr$chromosome_name[which(gene_chr$ensembl_gene_id == gene |
                                            gene_chr$hgnc_symbol == gene)]



    # If a path to downloaded data is given
    if (!is.na(path)) {
        # Check if last character of path is "/", if not, append "/"
        path <- ifelse(substring(path, nchar(path)) == "/",
                        path,
                        paste0(path, "/"))

        # If length is defined
        if (!is.na(length)) {
            if (length < 7 | length > 20) {
                stop("Length must be between 7 and 20")
            }

            # Define file path
            file <- paste0(path,
                            as.character(length),
                            "bp_dist1000_chr",
                            chromosome,
                            ".txt")

            # Read in file by chunks and select only rows corresponding to gene
            numgenes <- as.data.frame(
                readr::read_delim_chunked(
                    file,
                    readr::DataFrameCallback$new(gen_filter(gene)),
                    chunk_size = 10000,
                    delim = c("\t"),
                    col_types = col_types
                ),
                stringsAsFactors = FALSE
            )
            rm(file)
        }

        # If length not defined
        else {
            # Get all files of gene's chromosome number
            files <-
                paste0(path, list.files(
                    path = path,
                    pattern = paste0("bp_dist1000_chr",
                                    chromosome, ".txt")
                ))

            # Initialize empty df for relevant input
            numgenes <- data.frame()

            for (i in 7:20) {
                file <- paste0(path,
                                as.character(i),
                                "bp_dist1000_chr",
                                chromosome,
                                ".txt")

                temp <- as.data.frame(
                    readr::read_delim_chunked(
                        file,
                        readr::DataFrameCallback$new(gen_filter(gene)),
                        chunk_size = 10000,
                        delim = c("\t"),
                        col_types = col_types
                    ),
                    stringsAsFactors = FALSE
                )

                # Stop loop if current length has no results
                if (nrow(temp) == 0) {
                    break
                }

                numgenes <- rbind(numgenes, temp)
                rm(temp)
            }
            rm(files, file)

        }


        # If no given path to downloaded data, load included data subset
    } else {
        if (!(gene %in% c("GAA", "ENSG00000171298"))) {
            stop("Use gene GAA / ENSG00000171298, or download
                full dataset and specify path")
        }

        # If length is defined
        if (!is.na(length)) {
            if (length < 7 | length > 20) {
                stop("Length must be between 7 and 20")
            }

            # Load file corresponding to defined length and gene's chromosome
            numgenes <- get(paste0(as.character(length),
                                    "bp_dist1000_chr17"))

            # Filter only resuls of queried gene
            numgenes <-
                numgenes[which(numgenes$ensembl_gene_id == gene |
                                numgenes$hgnc_symbol == gene),]

        }
        # If length not defined
        else {
            # Load all internal files, corresponding to gene's chromosome number
            numgenes <- data.frame()

            for (i in 7:20) {
                input <- get(paste0(as.character(i),
                                    "bp_dist1000_chr17"))
                temp <- input[which(input$ensembl_gene_id == gene |
                                        input$hgnc_symbol == gene),]
                numgenes <- rbind(numgenes, temp)
            }
            rm(i, input, temp)
        }
    }
    # Clear memory
    gc(verbose = FALSE)

    # Define mismatch checking variable (1 for T, 0 for F)
    checkMismatch <- ifelse(mismatch == TRUE, 1, 0)

    # Filter by mismatch value, either none, or both 1 and 0
    results <- numgenes[which(numgenes$mismatch <= checkMismatch),]
    rm(numgenes)

    # Format numeric cols
    results$repeat_length <- as.numeric(results$repeat_length)
    results$distance <- as.numeric(results$distance)

    # Filter on mindist and maxdist
    results <- results[which(results$distance >= mindist &
                                results$distance <= maxdist),]

    # Sort results by repeat length, chromosome number, repeat sequence,
    # and start position
    results <-
        results[order(results$repeat_length,
                        results$chromosome,
                        results$repeat_seq,
                        results$start),]

    # No results
    if (nrow(results) == 0) {
        print("NO RESULT FOUND")
        toc()
    } else {
        # summary df
        summ <- data.frame(repeat_length =
                                sort(as.numeric(unique(
                                    results$repeat_length
                                ))),
                            unique_seqs = NA)

        # For each repeat length in results: number unique repeat_seq, number
        # unique instances, number structures, average distance
        for (i in summ$repeat_length) {
            temp <- results[which(results$repeat_length == i),]

            # Temp variable with just the sequences and start/ends
            inst <- rbind(temp[, c(3:5)],
                            setNames(temp[, c(6:8)],
                                    c("repeat_seq", "start", "end")))

            summ$unique_seqs[which(summ$repeat_length == i)] <-
                length(unique(inst$repeat_seq))
            summ$tot_instances[which(summ$repeat_length == i)] <-
                nrow(inst[!duplicated(inst),])
            summ$tot_structures[which(summ$repeat_length == i)] <-
                nrow(temp)
            summ$avg_dist[which(summ$repeat_length == i)] <-
                mean(as.numeric(temp$distance))
        }

        # Results normalizd by gene length
        gene_length <-
            as.numeric(strsplit(results$gene_range[1], "-")[[1]][2]) -
            as.numeric(strsplit(results$gene_range[1], "-")[[1]][1])
        summ$norm_instances_bp <- summ$tot_instances / gene_length
        summ$norm_instances_Mb <-
            summ$tot_instances / gene_length * 1e+06
        summ$norm_structures_bp <- summ$tot_structures / gene_length
        summ$norm_structures_Mb <-
            summ$tot_structures / gene_length * 1e+06

        # Print summ to console
        if (is.na(length)) {
            writeLines("\tParameters\n")
        } else {
            writeLines(paste0("\tParameters\n Repeat length:  ", length, " bp"))
        }
        writeLines(paste0(
            " \n Gene:            ",
            results$ensembl_gene_id[1],
            " / ",
            results$hgnc_symbol[1],
            " \n Gene length:     ",
            gene_length,
            " bp\n Transcript ID:   ",
            results$ensembl_transcript_id[1],
            "\n Distance:        ",
            mindist,
            "-",
            maxdist,
            " bp",
            "\n Mismatch:        ",
            mismatch,
            "\n\n"
            # sep = ""
        ))

        # Print summ df
        print(summ)
        writeLines("\n")
        results <- results[order(as.numeric(rownames(results))),]
        results <- results[,c(1,2,4,5,7,8,3,15,6,16,9:14,17,18)]
        colnames(results)[3:4] <- c("start1", "end1")
        colnames(results)[7] <- "repeat_seq1"
        colnames(results)[8] <- "intron_exon1"

        if (format == 'GInteractions'){
            ind1 <- c(1, 3, 4, 7:8)
            ind2 <- c(1, 5, 6, 9:10)

            reg1 <- GenomicRanges::makeGRangesFromDataFrame(results[,ind1],
                                            keep.extra.columns=TRUE,
                                            ignore.strand=FALSE,
                                            seqinfo=NULL,
                                            seqnames.field="chromosome",
                                            start.field="start1",
                                            end.field="end1",
                                            strand.field="strand",
                                            starts.in.df.are.0based=FALSE)
            reg2 <- GenomicRanges::makeGRangesFromDataFrame(results[,ind2],
                                            keep.extra.columns=TRUE,
                                            ignore.strand=FALSE,
                                            seqinfo=NULL,
                                            seqnames.field="chromosome",
                                            start.field="start2",
                                            end.field="end2",
                                            strand.field="strand",
                                            starts.in.df.are.0based=FALSE)

            gi <- InteractionSet::GInteractions(reg1, reg2)

            ind.metadata <- c(12:18)

            info <- colnames(results)[ind.metadata]

            mcols(gi)[, info] <- results[,ind.metadata]
            results <- gi
        }

        toc()

        # Output list of summ and detailed results
        if (summary == FALSE) {
            out <- results
        } else {
            summary <- summ
            out <- tibble::lst(summary, results)
        }
        invisible(out)
    }
}

test_that("Querying of internal data is correct", {
    gaa <- gene_lookup("GAA", length = 10)

    expect_equal(nrow(gaa), 690)
    expect_equal(unique(gaa$repeat_length), 10)
    expect_equal(unique(gaa$hgnc_symbol), "GAA")
    expect_equal(length(unique(gaa$mismatch)), 2)

    gaa <- gene_lookup("GAA", summary = TRUE)
    expect_equal(nrow(gaa$summary), 10)
    expect_equal(nrow(gaa$results), 24843)
    expect_false(gaa$summary$repeat_length[10] > 16)

    gaa <- gene_lookup("GAA", length = 10, mismatch = FALSE)
    expect_equal(nrow(gaa), 34)
    expect_equal(length(unique(gaa$mismatch)), 1)

})

test_that("multiplication works", {
  expect_equal(2 * 2, 4)
})

test_that("Incorrect or missing input parameters gives errors", {
    expect_error(gene_lookup(),
                "missing")
    expect_error(gene_lookup("ABCDE"),
                 "Incorrect gene ID")
    expect_error(gene_lookup("GAA", mindist = 100, maxdist = 10),
                 "mindist must be less than")
    expect_error(gene_lookup("GAA", format = "GRanges"),
                 "Format must be one of")
    expect_error(gene_lookup("GAA", length = 3),
                 "Length must be between")
    expect_error(gene_lookup("MTOR", path = NA),
                 "GAA")
})

#' Gene chromosome location
#'
#' A dataset containing two formats of gene names and associated
#' chromosome number.
#'
#' @format A data frame with 60571 rows and 3 variables:
#' \describe{
#'   \item{chromosome_name}{chromosome}
#'   \item{ensembl_gene_id}{Ensembl gene ID of gene}
#'   \item{hgnc_symbol}{HGNC symbol of gene}
#' }

"gene_chr"

#'
#' R/sysdata.rda
#'
#' Internal data parsed by the `gene_lookup()` function if no input
#' file directory is specified in the `path` parameter.
#'
#' The data included contains a subset of the EDIR database
#' (from https://osf.io/m3gvx/ or http://193.70.34.71/EDIR.tar.gz)
#' representing the results for the gene GAA/ENSG00000171298 on
#' chromosome 17.
#'
#' `sysdata.rda` contains the `genes_chr` dataset of gene names and
#' corresponding chromosome numbers, as well as the  GAA subset of
#' EDIR. For the latter, the data is separated by the results of each
#' possible repeat lengths (7-20 bp) available in the EDIR database.
#'

# -----------
# IMPORT DATA
# -----------

# Genes and chromosomes table
gene_chr <- readRDS("C:/Users/rockp/AppData/Local/Packages/
                    CanonicalGroupLimited.Ubuntu18.04onWindows_
                    79rhkp1fndgsc/LocalState/rootfs/home/laura/
                    Data_input/genes_chromosome.rds")

# Get files (chr17 subset from EDIR database acquired from
# https://osf.io/m3gvx/ or http://193.70.34.71/EDIR.tar.gz)
dir <- "../../../AppData/Local/Packages/
    CanonicalGroupLimited.Ubuntu18.04onWindows_79rhkp1fndgsc
    /LocalState/rootfs/home/laura/EDIR_chr17"
files <- list.files(dir, pattern = "*_dist1000_*")
filenames <- unlist(lapply(files,
                           function(x) strsplit(x, "\\.")[[1]][1]))


# -----------------------
# SUBSETTING EDIR RESULTS
# -----------------------

# For each file
for (i in 1:length(files)) {
    file <- filenames[i]
    print(file)

    # Import data
    temp <- readRDS(paste0("../../../AppData/Local/Packages/
                           CanonicalGroupLimited.Ubuntu18.04onWindows_
                           79rhkp1fndgsc/LocalState/rootfs/home/laura/
                           EDIR_chr17/", file, ".rds"))

    # Extract GAA only results
    temp <- temp[which(temp$hgnc_symbol=="GAA"),]

    # Assign to variable with same name as file
    assign(file, temp)
}

# ----------------------------------------
# STORING AS sysdata.rda FOR INTERNAL DATA
# ----------------------------------------

# Save all files as list of "gene_chr" and individual dataframes from
# dataset. Stored in "R/sysdata.rda" for function parsing
save(list = c("gene_chr", filenames[1:length(filenames)]),
     file = "R/sysdata.rda",
     compress = "xz")

---
title: "EDIRquery"
author: "Laura D.T. Vo Ngoc"
date: "`r Sys.Date()`"
# output: rmarkdown::html_vignette
output: rmarkdown::pdf_document
sansfant: Calibri
vignette: >
  %\VignetteIndexEntry{EDIRquery}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction

Intragenic exonic deletions are known to contribute to genetic diseases and are 
often flanked by regions of homology. The Exome Database of Interspersed Repeats
(EDIR) was developed to provide an overview of the positions of repetitive 
structures within the human genome composed of interspersed repeats encompassing
a coding sequence. The package `EDIRquery` provides user-friendly tools to query
this database for genes of interest.



# Dataset

EDIR provides a dataset of pairwise repeat structures in which both sequences 
are located within a maximum of 1000 bp from each other, and fulfill one of the 
following selection criteria:

-   \>= 1 repeat located in an exon

-   Both repeats situated in different introns flanking one or more exons

A subset of EDIR is provided as example data, representing a subset of the 
interspersed repeats data for the gene GAA (ENSG00000171298) on chromosome 17.

<!-- To query the full the database, obtain the files at `(insert link here)` 
and provide the data directory to `gene_lookup()` in the `path` parameter. -->

To query the full the database, provide the data directory to `gene_lookup()` in
the `path` parameter.



# Usage

## Installation

To install this package, enter the following in R:

```{r, eval = FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("EDIRquery")
```

Then load the package:

```{r, message = FALSE, warning = FALSE}
library("EDIRquery")
```

EDIR can easily be queried using the `gene_lookup` function, 
using the gene name and additional parameters:

| Argument | Description                                                                                                                                       | Default |
|----------------|---------------------------------------------|-----------|
| gene     | **required:** The gene name (ENSEMBLE ID or HGNC symbol)                                                                                          | \-      |
| length   | Repeat sequence length, must be between 7 and 20. If NA, results will include all available lengths in dataset for queried gene  | NA      |
| mindist  | Minimum spacer distance (bp) between repeats                                                                                                      | 0       |
| maxdist  | Maximum spacer distance (bp) between repeats                                                                                                      | 1000    |
| format  | Output table format. One of 'data.frame', 'GInteractions'.                                                                                                      | 'data.frame'    |
| summary  | Logical value indicating whether to store summary                                                                                                 | FALSE   |
| mismatch | Logical value indicating whether to allow 1 mismatch in sequence                                                                                  | TRUE    |
| path     | String containing path to directory holding downloaded dataset files. If not provided (`path = NA`), example subset of data will be used | NA      |



## Examples

A summary of the input printed to console, including the gene name, gene length 
(bp), Ensembl transcript ID, queried distance between repeats (default: 0-1000 
bp), and an overview of total results for the given repeat length. Console 
outputs include runtime.

Example querying the gene "GAA" with repeats of length 7, and allowing for 
1 mismatch:

```{r}
# Summary of results (printed to console)
gene_lookup("GAA", length = 7, mismatch = TRUE)
```

If no `length` is provided, a summary of all available repeat length results will
be printed:

```{r}
# Summary of results (printed to console)
gene_lookup("GAA", mismatch = TRUE)
```

Storing the output in a variable allows viewing of the individual results in the 
output dataframe:

```{r}
# Database output of query
results <- gene_lookup("GAA", length = 7, mismatch = TRUE)
head(results)
```

Changing the `format` parameter to `GInteractions` returns a GenomicInteractions 
object instead of a dataframe:

```{r}
# Database output of query
results <- gene_lookup("GAA", length = 7, format = "GInteractions", mismatch = TRUE)
head(results)
```


# Session info

```{r}
# Database output of query
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/EDIRquery.R
\name{gene_lookup}
\alias{gene_lookup}
\title{Look Up a Gene in EDIR Dataset}
\usage{
gene_lookup(
  gene,
  length = NA,
  mindist = 0,
  maxdist = 1000,
  format = "data.frame",
  summary = FALSE,
  mismatch = TRUE,
  path = NA
)
}
\arguments{
\item{gene}{The gene name (ENSEMBL ID or HGNC symbol)}

\item{length}{Repeat sequence length, must be between 7 and 20. Defaults to
NA. If NA, results will include all available lengths in dataset for queried
gene.}

\item{mindist}{Minimum spacer distance between repeats. Defaults to 0.}

\item{maxdist}{Maximum spacer distance between repeats. Defaults to 1000.}

\item{format}{Output table format. One of 'data.frame', 'GInteractions'.
Defaults to 'data.frame'.}

\item{summary}{Logical value indicating whether to store summary. Defaults
to FALSE.}

\item{mismatch}{Logical value indicating whether to allow 1 mismatch in
sequences. Defaults to TRUE.}

\item{path}{String containing path to directory holding downloaded dataset
files. Defaults to NA. If not provided (\code{path} = NA),
\code{gene_lookup()} will use subset of data provided as example.}
}
\value{
A data.frame of the results from the EDIR database. If
\code{summary = TRUE}, returns a tibble containing the summary
(\verb{$summary}), and query results (\verb{$results}).
}
\description{
This function searches for a specified gene in the EDIR dataset. A gene name
is a required parameter.
}
\details{
Summary of results printed to console includes gene name, gene length (bp),
Ensembl transcript ID, queried distance between repeats (default: 0-1000 bp),
and an overview of total results for the given repeat length. Console outputs
include runtime.
}
\examples{
## With given repeat length,
gene_lookup("GAA", length = 7, mindist = 10, maxdist = 1000,
            mismatch = TRUE)

## Without specified repeat length
gene_lookup("GAA", mindist = 0, maxdist = 1000, mismatch = TRUE)

## To access query results, store in variable
output <- gene_lookup("GAA", length = 7, mindist = 10, maxdist = 1000,
                        mismatch = FALSE)
head(output)

## With summary = TRUE
output <- gene_lookup("GAA", length = 10, mindist = 10, maxdist = 1000,
                        summary = TRUE,
                        mismatch = TRUE)
output$summary
head(output$results)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{gene_chr}
\alias{gene_chr}
\title{Gene chromosome location}
\format{
A data frame with 60571 rows and 3 variables:
\describe{
\item{chromosome_name}{chromosome}
\item{ensembl_gene_id}{Ensembl gene ID of gene}
\item{hgnc_symbol}{HGNC symbol of gene}
}
}
\usage{
gene_chr
}
\description{
A dataset containing two formats of gene names and associated
chromosome number.
}
\keyword{datasets}
